﻿; ------------------------------------------------------------------------------------
; Stack Machine - Virtuelles Register
; PB 4.5+ OS: Windows/Linux/MacOS Architecture: x86/x64
; Author: Alexander Aigner, cxAlex @ purebasic.fr/german
; ------------------------------------------------------------------------------------

; Eine Long-Variable mit Gettern/Settern/Inc/Dec. Der Source wird dadurch verständlicher

Interface VirtualRegister
  Get.l() ; Register-Wert lesen
  Set(Value.l) ; Register-Wert schreiben
  Inc() ; Um OP-Code erhöhen
  Dec() ; Um OP-Code erniedreigen
  Free() ; Register freigeben
EndInterface

Structure _VirtualRegister_Data
  *VTable
  Value.l
EndStructure

Procedure _VReg_New()
  Protected *VR._VirtualRegister_Data = AllocateMemory(SizeOf(_VirtualRegister_Data))
  With *VR
    \VTable = ?_VReg_VTable
  EndWith
  
  ProcedureReturn *VR
EndProcedure

Procedure _VReg_Set(*VR._VirtualRegister_Data, Value.l)
  With *VR
    \Value = Value
  EndWith
EndProcedure

Procedure _VReg_Inc(*VR._VirtualRegister_Data)
  With *VR
    \Value + 1
  EndWith
EndProcedure

Procedure _VReg_Dec(*VR._VirtualRegister_Data)
  With *VR
    \Value - 1
  EndWith
EndProcedure

Procedure.l _VReg_Get(*VR._VirtualRegister_Data)
  With *VR
    ProcedureReturn \Value
  EndWith
EndProcedure

Procedure _VReg_Free(*VR._VirtualRegister_Data)
  With *VR
    FreeMemory(*VR)
  EndWith
EndProcedure

DataSection
  _VReg_VTable:
  Data.i @_VReg_Get()
  Data.i @_VReg_Set()
  Data.i @_VReg_Inc()
  Data.i @_VReg_Dec()
  Data.i @_VReg_Free()
EndDataSection
; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 6
; Folding = --
; EnableXP
; CPU = 1